#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import sys
from PyQt4 import QtCore, QtGui

from Ui_styletest import Ui_StyleTest


class PlastiqueStyle(QtGui.QPlastiqueStyle):
    def __init__(self):
        print "PlastiqueStyle.__init__"
        super(PlastiqueStyle, self).__init__()

    @QtCore.pyqtSlot(QtGui.QSizePolicy.ControlType, QtGui.QSizePolicy.ControlType, QtCore.Qt.Orientation, QtGui.QStyleOption, QtGui.QWidget)
    def layoutSpacingImplementation(self, control1, control2, orientation,
                                    option = None, widget = None):
        print "layoutSpacingImplementation(%s, %s, %s, %s, %s)" % (control1, control2, orientation, option, widget)
        return super(PlastiqueStyle, self).layoutSpacingImplementation(control1, control2, orientation, option, widget)

class StyleTest(QtGui.QWidget, Ui_StyleTest):
    def __init__(self, parent = None):
        super(StyleTest, self).__init__(parent)
        self.setupUi(self)

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    style = app.style()
    print style, style.metaObject().className()
    #style = QtGui.QStyleFactory.create("Plastique")
    plastiqueStyle = PlastiqueStyle()
    app.setStyle(plastiqueStyle)
    style = app.style()
    print style, style.metaObject().className()
    win = StyleTest()
    win.show()
    QtGui.QShortcut("Ctrl+Q", win, lambda: win.close())
    ret = app.exec_()
    sys.exit(ret)
